/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
*
* \brief  AVR476: ڐGu
*
*	̧ق͐ڐGνĉp܂݂܂B
*
* \par pLq:
*      AVR476: ڐGu
*
* \author
*	O				: PC\n
*	Atmel Corporation	: http://www.atmel.com \n
*	xEҰ			: avr@atmel.com
*
* $Revision: 1.1 $
* $Date: 2008-04-17 13:25:40 +0200  $  \n
*
* 쌠 (c) 2008, Atmel Corporation S\ς
*
* ύXL܂͖ſ޲؂̌`ł̍ĔzzƎgp͈ȉ̏ɍv
* ɋ܂B
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	 Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	 ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	 (ۏ)ɎgpłȂ܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
* ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
* fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
* RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
* Ȃł傤B
*****************************************************************************/


/************************************************************************//**
 * ݸٰ ̧
****************************************************************************/

#include <ioavr.h>
#include <intrinsics.h>
#include "touch_lib_krs.h"

/************************************************************************//**
 * 萔
****************************************************************************/

#define TICKS_PER_MS			16u
#define MEASUREMENT_PER_MS		20u
//#define WDT_PERIOD_MS			16u

#define DBG_DATA				PORTB_Bit4
#define DBG_CLK					PORTB_Bit5

#define DDR_DBG_DATA			DDRB_Bit4
#define DDR_DBG_CLK				DDRB_Bit5

/* ޯ ްŕԂ銴m` */
#define SENSOR_TYPE_UNASSIGNED	0x00u
#define SENSOR_TYPE_KEY			0x01u
#define SENSOR_TYPE_ROTOR		0x02u
#define SENSOR_TYPE_SLIDER		0x03u

#define PRO_ID					0x01u
#define RESET_BIT				0x80u
/* SPI޲ėvf */
#define PROTOCOL_ID				0x00u
#define STATUS					0x01u
#define WHEEL_POS				0x04u
#define KEYS_1					0x05u
#define KEYS_2					0x06u

#define NUM_STATUS_BYTES		6u
#define FIRST_STATUS_BYTE		0x01u

#define MATCH					0x01u
#define NO_MATCH				0x00u

#define PORT_CHANGE_PIN			PORTA_Bit0
#define DDR_CHANGE_PIN			DDRA_Bit0

/************************************************************************//**
 * ^
****************************************************************************/

static void init_system( void );			// νĉpA݁AޯނȂǏ
static void Init_Slave_IntContr (void);		// SPI]u

/* ޯފ֐ */
static void report_debug_data( void );
static void output_to_debugger( const uint8_t *p, uint8_t count );
static void send_debug_byte( uint8_t data );

uint8_t comms_match(void);

/************************************************************************//**
 * Sϐ
****************************************************************************/

/************************************************************************//**
 * ÓIϐ
****************************************************************************/

/* /ISRɂĐݒ肳錻݂̎ */
static uint16_t current_time_ms = 0u;

static uint8_t measurement_period_ms = 20u;
static uint8_t wdt_period_ms = 125u;
static uint8_t val = 0u;
static uint8_t spi_bytes[7u]; 

/* Ōɑڼ޽̕ */
static uint8_t sent_status_out[NUM_STATUS_BYTES] = {0u, 0u, 0u, 0u, 0u, 0u};
volatile char IOReg;

/************************************************************************//**
* O	: main\n
*------------------------------------------------------------------------------\n
* ړI	: 庰ޓ_\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/

__task void main( void )
{

	__delay_cycles( 500UL );	// 500sxҋ@
	init_system();				// νĉpA݁AޯނȂǏ
	Init_Slave_IntContr();		// SPI]u

	/* m0`15 : 0`15̷- */
	qt_enable_key( CHANNEL_4,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_2,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_3,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_6,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_5,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_7,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_1,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_0,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_8,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_9,  AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_10, AKS_GROUP_1, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_11, AKS_GROUP_1, 10u, HYST_6_25 );
//	qt_enable_key( CHANNEL_12, NO_AKS_GROUP, 10u, HYST_6_25 );
//	qt_enable_key( CHANNEL_13, NO_AKS_GROUP, 10u, HYST_6_25 );
//	qt_enable_key( CHANNEL_14, NO_AKS_GROUP, 10u, HYST_6_25 );
//	qt_enable_key( CHANNEL_15, NO_AKS_GROUP, 10u, HYST_6_25 );

	/* m17 : 12`15̉] */
	qt_enable_rotor( CHANNEL_12, CHANNEL_15,  AKS_GROUP_1, 32u, HYST_6_25, RES_8_BIT, 0u );

	/* emɑ΂W\ݒ */
	qt_burst_lengths[0u] = 92u;
	qt_burst_lengths[1u] = 85u;
	qt_burst_lengths[2u] = 85u;
	qt_burst_lengths[3u] = 86u;
	qt_burst_lengths[4u] = 42u;
	qt_burst_lengths[5u] = 40u;
	qt_burst_lengths[6u] = 42u;
	qt_burst_lengths[7u] = 40u;
	qt_burst_lengths[8u] = 52u;
	qt_burst_lengths[9u] = 92u;
	qt_burst_lengths[10u] = 105u;
	qt_burst_lengths[11u] = 64u;
	qt_burst_lengths[12u] = 51u;
	qt_burst_lengths[13u] = 51u;
	qt_burst_lengths[14u] = 51u;
	qt_burst_lengths[15u] = 51u;

//	qt_max_on_duration = 50u;		// őON
	qt_init_sensing();				// ڐGm
	__enable_interrupt();			// S̊荞݋

	/* JԂ */
	for( ; ; )
	{
		qt_measure_sensors( current_time_ms );					// ڐGm푪
		/* SPI޲č\ݒ */
		__disable_interrupt();									// S̊荞݋֎~
		/* PhilipsʐMdlƂĒli[ */
		spi_bytes[WHEEL_POS] = qt_touch_status.rotor_slider_values[0u];
		spi_bytes[KEYS_1]	 = qt_touch_status.sensor_states[0u];
		spi_bytes[KEYS_2]	 = qt_touch_status.sensor_states[1u];
		spi_bytes[KEYS_2]	 = ((spi_bytes[KEYS_1]>>6)| (spi_bytes[KEYS_2]<<3));
		spi_bytes[KEYS_2]	&= 0x3Bu;
		spi_bytes[KEYS_1]	&= 0x3Fu;
		if ((spi_bytes[KEYS_2]|spi_bytes[KEYS_1]) == 0)			// ڐGȂŁA
		{
			spi_bytes[STATUS]   &= 0xFBu;						//  ޯĎՕLޯĉ(0)
		}
		else													// ڐGLŁA
		{
			spi_bytes[STATUS]   |= 0x04u;						//  ޯĎՕLޯĐݒ(1)
		}
		if (((qt_touch_status.sensor_states[1u])& 0x10)== 0)	// ֐ڐGȂŁA
		{
			spi_bytes[STATUS]   &= 0xFDu;						// ֐ڐGޯĉ(0)
		}
		else													// ֐ڐGLŁA
		{
			spi_bytes[STATUS]   |= 0x02u;						// ֐ڐGޯĐݒ(1)
		}
//		report_debug_data();									// νĂޯ ް

		/* ωǂ𔻒 */
		if( NO_MATCH == comms_match() )							// O/ł̒lsvŁA
		{
			PORT_CHANGE_PIN = 1u;								// ω=H(ݒ)
		}

		__enable_interrupt();									// S̊荞݋
		current_time_ms += measurement_period_ms;				// ݎԐis/XV
		__disable_interrupt();									// S̊荞݋֎~
		__watchdog_reset();										// ޯ ς̊S1ԋx~ۏ؂邽߂ɳޯ  ؾ
		WDTCSR = (1<<WDCE )|(1<<WDE  );							// ޯ ϕύX
		WDTCSR = (1<<WDIF)|(1<<WDIE)|							// ޯފ荞ݗv׸މ(0)Aޯފ荞ݓ싖
				 (1<<WDCE )|(0<<WDE  )|							// \ʋ̏ꍇł̼ ؾē`Ԃ֎~
				 (0<<WDP3 )|(0<<WDP2 )|(1<<WDP1)|(1<<WDP0);		// ޯތoߎԂ125msɐݒ
		PCMSK0 = 0x04u;											// /SSݕω荞݋
		PCICR  = 0x01u;											// ݕω0Q荞݋
		PORTA_Bit3 = 0u;										// [ޯޗp]PA3=L(x~ڍs)
		__enable_interrupt();									// S̊荞݋
		__sleep();												// ܰ޳݋x~`Ԉڍs

		PORTA_Bit3 = 1u;										// [ޯޗp]PA3=H(x~Eo)
		__disable_interrupt();									// S̊荞݋֎~
		PCICR = 0u;												// ݕωnQ荞ݓ֎~
		__watchdog_reset();										// ޯ  ؾ
		WDTCSR &= ~(1<<WDIE);									// ޯފ荞݋֎~
																// JԂ荞݂KvƂꍇA͏ȗ邱Ƃł܂B
		WDTCSR = (1<<WDCE )|(1<<WDE  );							// ޯ ϕύX
		WDTCSR = (1<<WDIF)|(0<<WDIE)|							// ޯފ荞ݓ֎~
				 (1<<WDCE )|(1<<WDE  )|							// ޯ  ؾē싖
				 (0<<WDP3 )|(1<<WDP2 )|(0<<WDP1)|(1<<WDP0);		// ޯތoߎԂ500msɐݒ
		__enable_interrupt();									// S̊荞݋
		current_time_ms += wdt_period_ms;				// ݎԐis/XV
	}
}

/************************************************************************//**
* O	: init_system\n
*------------------------------------------------------------------------------\n
* ړI	: νĉpA݁AޯނȂǂ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/

void init_system( void )
{
	/* 4MHzsݒ */
	CLKPR = 0x80u;										//  ۯOuύX
	CLKPR = 0x01u;										// 2(=4MHz)ݒ

	__watchdog_reset();									// ޯ ς̊S1ԋx~ۏ؂邽߂ɳޯ  ؾ
	WDTCSR = (1<<WDCE )|(1<<WDE  );						// ޯ ϕύX
	WDTCSR = (1<<WDIF)|(1<<WDIE)|						// ޯފ荞ݗv׸މ(0)Aޯފ荞ݓ싖
			 (1<<WDCE )|(0<<WDE  )|						// \ʋ̏ꍇł̼ ؾē`Ԃ֎~
			 (0<<WDP3 )|(1<<WDP2 )|(0<<WDP1)|(1<<WDP0);	// ޯތoߎԂ500msɐݒ

	SMCR |= (1<<SM1) | (1<<SE);							// ܰ޳݋x~`Ԃw
	MCUCR_PUD = 1u;										// Sٱߋ֎~

	/* ߰ ݏ */
	DDR_DBG_DATA = 1u;									// ޯ ް ݏo͐ݒ
	DDR_DBG_CLK  = 1u;									// ޯ ۯ ݏo͐ݒ
	DDR_CHANGE_PIN  = 1u;								// ωݏo͐ݒ
	PORT_CHANGE_PIN = 0u;								// ω=L(s)ݒ
	PORTA_Bit3 = 1u;									// x~=1()ݒ
	DDRA_Bit3  = 1u;									// x~ݏo͐ݒ

	/* SPI޲ď */
	spi_bytes[PROTOCOL_ID]	= PRO_ID;					// KID
	spi_bytes[STATUS]		= RESET_BIT;				// ؾ ޯĐݒ
	spi_bytes[2u]			= 0x00u;					// Xʒu(\)
	spi_bytes[3u]			= 0x00u;					// Yʒu(\)
	spi_bytes[WHEEL_POS]	= 0x00u;					// ֈʒu
	spi_bytes[KEYS_1]		= 0x00u;					// 7`0
	spi_bytes[KEYS_2]		= 0x00u;					// 15`8
}

/************************************************************************//**\
* O	: init_spi_slave\n
*------------------------------------------------------------------------------\n
* ړI	: SPI]u\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
void Init_Slave_IntContr (void)
{
	/* Set PB4(MISO) as output */
	DDRB    = (1<<PORTB4);								// MISO(PB4)o͐ݒ
	/* Enable SPI Interrupt and SPI in Slave Mode */
	SPCR  = (1<<SPIE)|(1<<SPE)|(1<<CPOL)|(1<<CPHA);		// SPI荞݋A]uݒ
	IOReg   = SPSR;										// ׸މ̂߂ɋǂ
	IOReg   = SPDR;										// ްǂ
	SPDR    = spi_bytes[PROTOCOL_ID];					// ްƂĐ擪޲(KID)ݒ
}

/************************************************************************//**
* O	: spi_isr\n
*------------------------------------------------------------------------------\n
* ړI	: SPI荞ݏٰ(ISR)\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/

/* 荞ٰ (荞ݐ䂳ꂽ)]u */
#pragma vector=SPI_STC_vect
__interrupt void ISR_SPI (void)
{
	if ( val == STATUS )									// O޲[1]ŁA
	{
		spi_bytes[STATUS] &= (uint8_t)(~RESET_BIT);			// ؾ ޯĉ(0)
	}

	if ( ( val >= FIRST_STATUS_BYTE ) && ( val <= (NUM_STATUS_BYTES + FIRST_STATUS_BYTE - 1u) ) )	// OMlڽ2`6ŁA
	{
		sent_status_out[val-FIRST_STATUS_BYTE] = spi_bytes[val];	// ۑl𒼑Oo͒lōXV
	}
	val  = SPDR;											// wԍ擾
	if (val <= 0x06u)										// SPI޲ĂŁA
	{
		SPDR = spi_bytes[val];								// wlMlƂĐݒ
	}
	else if (val == 0xA5u)									// ZwŁA
	{
		qt_calibrate_sensing();								// mZ
		SPDR= 0xA5u;										// ԂlMlƂĐݒ
	}
	else													// `wlŁA
	{
		SPDR = 0xFFu;										// MlS1ƂĐݒ
	}

	/* ωǂ𔻒 */
	if( MATCH == comms_match() )							// O/ł̒lvŁA
	{
		PORT_CHANGE_PIN = 0u;								// ω=L(sݒ)
	}
}

/************************************************************************//**
* O	: PCINT0_isr\n
*------------------------------------------------------------------------------\n
* ړI	: PCINT0 ISR\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
#pragma vector = PCINT0_vect
__interrupt void wake_up(void)
{
	PCICR = 0u;												// ݕω荞0Q֎~
//	PORTA_Bit3 = 1u;
}

/************************************************************************//**
* O	: report_debug_data\n
*------------------------------------------------------------------------------\n
* ړI	: νĂޯ ް\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	: Ȃ\n
****************************************************************************/

void report_debug_data( void )
{
//	output_to_debugger( (uint8_t *) &board_info, (uint8_t) sizeof( board_info ) );
	output_to_debugger( (uint8_t *) channel_signals, (uint8_t) sizeof( channel_signals ) );
	output_to_debugger( (uint8_t *) channel_references, (uint8_t) sizeof( channel_references ) );
	output_to_debugger( (uint8_t *) sensor_deltas, (uint8_t) sizeof( sensor_deltas ) );
	output_to_debugger( (uint8_t *) &qt_touch_status, (uint8_t) sizeof( qt_touch_status ) );
//	output_to_debugger( (uint8_t *) sensor_config, (uint8_t) sizeof( sensor_config ) );
}

/************************************************************************//**
* O	: output_to_debugger\n
*------------------------------------------------------------------------------\n
* ړI	: ޯ ̪֕޲đM\n
* 	: p		= M޲Ăւ߲\n
*         count	= M޲Đ\n
* o	: Ȃ\n
* 	: \n
****************************************************************************/

void output_to_debugger( const uint8_t *p, uint8_t count )
{
	uint8_t i;
	uint8_t data;

	for( i = 0u; i < count; i++ )	// w޲Đp
	{
		data = *p;					// Ήoް ޲Ď擾
		send_debug_byte( data );	// ޯ ̪޲đM
		p++;						// ߲is
	}
}

/************************************************************************//**
* O	: send_debug_byte\n
*------------------------------------------------------------------------------\n
* ړI	: ޯ ̪֒P޲đM\n
* 	: data = M޲\n
* o	: Ȃ\n
* 	: \n
****************************************************************************/

void send_debug_byte( uint8_t data )
{
	uint8_t i;

	for( i = 0u; i < 8u; i++ )						// 1޲(8ޯ)M
	{
		/* ޯ ް 0/1ݒ */
		if( data & 0x80u )							// Ήޯ=1ŁA
		{
			DBG_DATA = 1u;							// ޯ ް=Hݒ
		}
		else										// Ήޯ=0ŁA
		{
			DBG_DATA = 0u;							// ޯ ް=Lݒ
		}
		__delay_cycles( 5UL );						// ۯOݒ莞(2.5s)ҋ@
		data = (uint8_t)( data << 1u );				// ް ޲ ޯĈʒuړ(MSB=Ώޯ)

		/* ޯ ۯ ٽo */
		DBG_CLK = 1u;								// ޯ ۯ=H()
		__delay_cycles( 5UL );						// ٽ(2.5s)ҋ@
		DBG_CLK = 0u;								// ޯ ۯ=L()

		__delay_cycles( 5UL );						// ۯێ(2.5s)ҋ@
	}
	DBG_DATA = 0u;									// (޲ĊԒlp)ޯ ް=Lݒ
	__delay_cycles( 25UL );							// ޲Ċ(12.5s)ҋ@
}

/************************************************************************//**
* O	: comms_match(void)\n
------------------------------------------------------------------------------\n
* ړI	: K؂ڼ޽̌ݒlɑ΂ŏIMl̔r\n
* 	:\n
* o	: ڼ޽svȂNO_MATCHAvȂMATCHԂ܂B
* 	: ڼ޽ASʏԂƐʒuɊÂĈv𔻒肵܂B\n
****************************************************************************/
uint8_t comms_match(void)
{
	uint8_t i;

	for( i = 0u; i < NUM_STATUS_BYTES; i++ )		// ԍŏI޲Ă܂Ōp
	{
		if ( sent_status_out[i] != spi_bytes[(FIRST_STATUS_BYTE+i)] )	// Ή޲ĕsvŁA
		{
			return(NO_MATCH);						// sv׸ނƋɕA
		}

	}
	return(MATCH);									// S޲Ĉv׸ނƋɕA

}
/